﻿Module mdlAi
    Public Function CreateAiMove(ByVal Player As strPlayer) As Point
        Dim tempMove As Point
        If Player.Strength = enmCPUStrength.Easy Then
            tempMove = AiEasy(Player.ID)
        ElseIf Player.Strength = enmCPUStrength.Normal Then
            tempMove = AiNormal(Player.ID)
        ElseIf Player.Strength = enmCPUStrength.Hard Then
            tempMove = AiHard(Player.ID)
        End If
        Return tempMove
    End Function

    Public Function AiEasy(ByVal PlayerID As Byte) As Point
        Dim PointArray(8) As Point
        Dim CurrentID As Byte
        Dim RandomNum As New Random

        For I = 0 To 2
            For J = 0 To 2
                If FullMatrix(I, J) = 0 Then
                    PointArray(CurrentID) = New Point(I, J)
                    CurrentID += 1
                End If
            Next
        Next

        CurrentID = RandomNum.Next(0, CurrentID)
        AiEasy = PointArray(CurrentID)
    End Function

    Private Function AiNormal(ByVal PlayerID As Byte) As Point
        Dim AttackPoints(2, 2) As Byte
        Dim PlayerOneWeight(,) As Byte = GetPlayerLineWeight(0)
        Dim PlayerTwoWeight(,) As Byte = GetPlayerLineWeight(1)
        Dim FullWeight(,) As Byte = GetFullLineWeight()
        Dim PlayerNum As Byte = 1 + PlayerID * 3

        For I = 0 To 3
            For J = 0 To 2
                If FullWeight(I, J) = PlayerNum * 2 Then ' Win
                    Return GetLastField(I, J)
                End If
            Next
        Next
        For I = 0 To 3
            For J = 0 To 2
                If FullWeight(I, J) = GetOpponentMulti(PlayerNum) * 2 Then 'Block
                    Return GetLastField(I, J)
                End If
            Next
        Next

        Return AiEasy(PlayerID)
    End Function

    Private Function AiHard(ByVal PlayerID As Byte) As Point
        Dim PlayerNum As Byte = 1 + PlayerID * 3
        Dim RandomNum As New Random
        Dim FullWeight(,) As Byte = GetFullLineWeight()


        For I = 0 To 3
            For J = 0 To 2
                If FullWeight(I, J) = PlayerNum * 2 Then ' Win
                    Return GetLastField(I, J)
                End If
            Next
        Next
        For I = 0 To 3
            For J = 0 To 2
                If FullWeight(I, J) = GetOpponentMulti(PlayerNum) * 2 Then 'Block
                    Return GetLastField(I, J)
                End If
            Next
        Next

        If MoveCount Mod 2 = 0 Then
            Select Case MoveCount
                Case 0
                    FirstCorner(PlayerID) = New Point(RandomNum.Next(0, 2) * 2, RandomNum.Next(0, 2) * 2) 'Corner
                    Return FirstCorner(PlayerID)
                Case 2
                    If PlayerMatrix(GetOpponentID(PlayerID), 0, 2) = 1 Or _
                    PlayerMatrix(GetOpponentID(PlayerID), 2, 0) = 1 Or _
                    PlayerMatrix(GetOpponentID(PlayerID), 0, 0) = 1 Or _
                    PlayerMatrix(GetOpponentID(PlayerID), 2, 2) = 1 Then 'Enemy in one of the corners
                        HardPlayStyle = 0
                        Return GetEmptyCorner()
                    ElseIf PlayerMatrix(GetOpponentID(PlayerID), 1, 1) = 1 Then 'Enemy in center
                        HardPlayStyle = 1
                        Return New Point(GetCattyNumber(FirstCorner(PlayerID).X), GetCattyNumber(FirstCorner(PlayerID).Y))
                    Else 'Enemy in edge
                        HardPlayStyle = 2
                        Return New Point(1, 1)
                    End If
                Case 4
                    Select Case HardPlayStyle
                        Case 0 'Enemy in one of the corners
                            Return GetEmptyCorner()
                        Case 1 'Enemy in center
                            If GetEmptyCornerCount() = 3 Then
                                Return GetEmptyCorner()
                            End If
                        Case 2 'Enemy in edge
                            For I = 0 To 1
                                For J = 0 To 1
                                    If FullMatrix(I * 2, J * 2) = 0 Then 'Search for an empty corner
                                        If PlayerMatrix(GetOpponentID(PlayerID), I * 2, 1) = 0 And PlayerMatrix(GetOpponentID(PlayerID), 1, J * 2) = 0 Then
                                            Return New Point(I * 2, J * 2)
                                        End If
                                    End If
                                Next
                            Next
                    End Select
                Case 6
                    Select Case HardPlayStyle
                        Case 0 'Enemy in one of the corners
                            Return GetEmptyCorner()
                        Case 1 'Enemy in center
                            Return GetEmptyCorner()
                        Case 2 'Enemy in edge

                    End Select
                Case 8
                    Select Case HardPlayStyle
                        Case 0 'Enemy in one of the corners

                        Case 1 'Enemy in center

                        Case 2 'Enemy in edge

                    End Select
            End Select
        Else
            Select Case MoveCount
                Case 1
                    If PlayerMatrix(GetOpponentID(PlayerID), 1, 1) = 1 Then 'Enemy in center
                        HardPlayStyle = 0
                        Return New Point(RandomNum.Next(0, 2) * 2, RandomNum.Next(0, 2) * 2) 'Corner
                    Else 'Enemy not on Center
                        HardPlayStyle = 1
                        Return New Point(1, 1)
                    End If
                Case 3
                    Select Case HardPlayStyle
                        Case 0 'Enemy in center
                            Return GetEmptyCorner()
                        Case 1 'Enemy not on Center
                            If GetEmptyCornerCount() = 3 Then 'Enemy on Corner & Edge
                                For I = 0 To 1
                                    For J = 0 To 1
                                        If PlayerMatrix(GetOpponentID(PlayerID), I * 2, J * 2) = 1 Then 'Search for the Enemy Corner
                                            Return New Point(GetCattyNumber(I * 2), GetCattyNumber(J * 2))
                                        End If
                                    Next
                                Next
                            ElseIf GetEmptyCornerCount() = 4 Then 'Enemy 2x on Edge only
                                HardPlayStyle = 4
                                If Not PlayerMatrix(GetOpponentID(PlayerID), 1, 0) = PlayerMatrix(GetOpponentID(PlayerID), 1, 2) Then 'Enemy borders a corner
                                    If PlayerMatrix(GetOpponentID(PlayerID), 1, 0) = PlayerMatrix(GetOpponentID(PlayerID), 2, 1) Then
                                        If PlayerMatrix(GetOpponentID(PlayerID), 1, 0) = 1 Then
                                            Return New Point(2, 0)
                                        Else
                                            Return New Point(0, 2)
                                        End If
                                    ElseIf PlayerMatrix(GetOpponentID(PlayerID), 0, 1) = PlayerMatrix(GetOpponentID(PlayerID), 1, 0) Then
                                        If PlayerMatrix(GetOpponentID(PlayerID), 0, 1) = 1 Then
                                            Return New Point(0, 0)
                                        Else
                                            Return New Point(2, 2)
                                        End If
                                    End If
                                Else 'Enemy doesn't border a corner -> we win :)
                                    HardPlayStyle = 2
                                    Return GetEmptyEdge()
                                End If

                                Else 'Enemy 2x on Corner
                                    HardPlayStyle = 3
                                    Return GetEmptyEdge()
                                End If
                    End Select
                Case 5
                    Select Case HardPlayStyle
                        Case 0 'Enemy in center
                            Return GetEmptyCorner()
                        Case 1 'Enemy not on Center + Corner & Edge

                        Case 2 'Enemy not on Center + Enemy 2x on Edge only
                            If PlayerMatrix(GetOpponentID(PlayerID), 1, 0) = PlayerMatrix(GetOpponentID(PlayerID), 2, 1) Then
                                Return New Point(0, 2)
                            ElseIf PlayerMatrix(GetOpponentID(PlayerID), 0, 1) = PlayerMatrix(GetOpponentID(PlayerID), 1, 0) Then
                                Return New Point(2, 2)
                            End If
                        Case 3 'Enemy not on Center + Enemy 2x on Corner

                    End Select
                Case 7
                    Select Case HardPlayStyle
                        Case 0 'Enemy in center

                        Case 1 'Enemy not on Center + Corner & Edge

                        Case 2 'Enemy not on Center + Enemy 2x on Edge only

                        Case 3 'Enemy not on Center + Enemy 2x on Corner

                    End Select
            End Select
        End If

        Return AiNormal(PlayerID)
    End Function

    Public Function GetFullLineWeight() As Array
        Dim LineSum(3, 2) As Byte
        For I = 0 To 2
            For J = 0 To 2
                LineSum(0, I) += FullMatrix(I, J)
                LineSum(1, I) += FullMatrix(J, I)
            Next
            LineSum(2, 0) += FullMatrix(I, I)
            LineSum(3, 0) += FullMatrix(I, 2 - I)
        Next
        Return LineSum
    End Function

    Private Function GetEmptyCorner() As Point
        For I = 0 To 1
            For J = 0 To 1
                If FullMatrix(I * 2, J * 2) = 0 Then 'Search for an empty corner
                    Return New Point(I * 2, J * 2)
                End If
            Next
        Next
        Return New Point(-1, -1) 'Full
    End Function

    Private Function GetEmptyCornerCount() As Byte
        GetEmptyCornerCount = 0
        For I = 0 To 1
            For J = 0 To 1
                If FullMatrix(I * 2, J * 2) = 0 Then 'Search for an empty corner
                    GetEmptyCornerCount += 1
                End If
            Next
        Next
    End Function

    Private Function GetEmptyEdge() As Point
        For I = 0 To 1
            If FullMatrix(I, I + 1) = 0 Then 'Search for an empty edge
                Return New Point(I, I + 1)
            End If
            If FullMatrix(I + 1, I) = 0 Then 'Search for an empty edge
                Return New Point(I + 1, I)
            End If
        Next
    End Function

    Private Function GetEmptyEdgeCount() As Byte
        GetEmptyEdgeCount = 0
        For I = 0 To 1
            If FullMatrix(I, I + 1) = 0 Then 'Search for an empty edge
                GetEmptyEdgeCount += 1
            End If
            If FullMatrix(I + 1, I) = 0 Then 'Search for an empty edge
                GetEmptyEdgeCount += 1
            End If
        Next
    End Function

    Private Function GetCattyNumber(ByVal Number As Byte) As Byte
        If Number = 2 Then
            Return 0
        Else
            Return 2
        End If
    End Function

End Module
